% build model mean feature vector (Mean) and inverse of covariance matrices
% (Invcors) for 1 class given a set of N observed
% feature vectors (Vecs)

function [Mean,Invcor] = buildmodel(Vecs,N)

    Mean = mean(Vecs)';
    diffs = Vecs - ones(N,1)*Mean';
    Invcor = inv(diffs'*diffs/(N-1));
